Index: client/device.c
===================================================================
RCS file: /var/cvsroot/streamdev/client/device.c,v
retrieving revision 1.13
diff -u -r1.13 device.c
--- client/device.c	7 May 2007 12:18:18 -0000	1.13
+++ client/device.c	8 Jun 2007 14:54:54 -0000
@@ -51,12 +51,21 @@
 
 cStreamdevDevice::~cStreamdevDevice() {
 	Dprintf("Device gets destructed\n");
+
+	Lock();
 	m_Device = NULL;
-	delete m_TSBuffer;
-	delete m_Assembler;
+	m_Filters->SetConnection(-1);
+	ClientSocket.Quit();
+	ClientSocket.Reset();
+	Unlock();
+
+	Cancel(3);
+
 #if VDRVERSNUM >= 10300
-	delete m_Filters;
+	DELETENULL(m_Filters);
 #endif
+	DELETENULL(m_TSBuffer);
+	delete m_Assembler;
 }
 
 bool cStreamdevDevice::ProvidesSource(int Source) const {
@@ -149,7 +158,7 @@
 		if (m_Pids < 0) 
 			m_Pids = 0;
 
-		if(m_Pids < 1 && m_DvrClosed) { 
+		if (m_Pids < 1 && m_DvrClosed) { 
 			Dprintf("SetPid: 0 pids left -> CloseDvr()"); 
 			CloseDvrInt(); 
 		}
@@ -216,7 +225,7 @@
 }
 
 bool cStreamdevDevice::GetTSPacket(uchar *&Data) {
-	if (m_TSBuffer) {
+	if (m_TSBuffer && m_Device) {
 		Data = m_TSBuffer->Get();
 #if 1 // TODO: this should be fixed in vdr cTSBuffer
 		// simple disconnect detection
